/**
 * Copyright (c) 2018 MicroNova AG
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 *
 *     1. Redistributions of source code must retain the above copyright notice, this
 *        list of conditions and the following disclaimer.
 *
 *     2. Redistributions in binary form must reproduce the above copyright notice, this
 *        list of conditions and the following disclaimer in the documentation and/or
 *        other materials provided with the distribution.
 *
 *     3. Neither the name of MicroNova AG nor the names of its
 *        contributors may be used to endorse or promote products derived from
 *        this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 * ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package jenkins.plugins.exam.config.ExamPluginConfig

def f = namespace(lib.FormTagLib);

f.section(title: descriptor.displayName) {

    f.entry(title: _("Rest api Port"), field: "port") {
        f.number()
    }

    f.entry(title: _("License Server host"), field: "licenseHost") {
        f.textbox()
    }

    f.entry(title: _("License Server Port"), field: "licensePort") {
        f.number()
    }

    f.entry(title: _("timeout"), field: "timeout") {
        f.number()
    }

    f.entry(title: _("EXAM Model Connections")) {
        f.repeatableProperty(
                field: "modelConfigs",
                header: "EXAM Model",
                add: _("add EXAM model connection"))
    }

    f.block() {
        f.validateButton(
                title: _("test model connections"),
                progress: _("testing..."),
                method: "verifyModelConnections"
        )
    }

    f.entry(title: _("EXAM Report Connections")) {
        f.repeatableProperty(
                field: "reportConfigs",
                header: "EXAM Report",
                add: _("add EXAM report connection"))
    }
}
